
; Listing9i3.s		BOB mit Hintergrundwiederherstellung.
; Linke Taste zum Verlassen.

	SECTION	BLIT,CODE

;	include	"DaWorkBench.s"		; entferne das; vor dem Speichern mit "wo"

*****************************************************************************
	include	"/Sources/startup1.s"	; speichern Copperlist etc.
*****************************************************************************

			;5432109876543210
DMASET	EQU	%1000001111000000	; Bitplane, Copper, Blitter DMA


Start:
	move.l	#Bitplane,d0		; Zeiger auf das Bild
	lea	Bplpointers,a1			; Bitplanepointer
	moveq	#3-1,d1				; Anzahl Bitplanes (hier sind es 3)
PointBp:
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	swap	d0
	add.l	#40*256,d0			; + Lnge einer Bitplane !!!!!
	addq.w	#8,a1
	dbra	d1,PointBp

	lea	$dff000,a5				; Custom Register Base in a5
	move.w	#DMASET,$96(a5)		; DMACON - einschalten Bitplane, Copper, Blitter
	move.l	#Copperlist,$80(a5)	; Zeiger Copperlist
	move.w	d0,$88(a5)			; Start Copperlist
	move.w	#0,$1fc(a5)			; AGA "deaktivieren"
	move.w	#$c00,$106(a5)		; AGA "deaktivieren"
	move.w	#$11,$10c(a5)		; AGA "deaktivieren"

Mouse:
	bsr.w	ReadMouse			; Koordinaten lesen
	bsr.s	ControlCoordinate	; verhindert, dass der Bob den Bildschirm verlsst
	bsr.w	SaveBackground		; speichert den Hintergrund
	bsr.s	DesignObject		; zeichnet den Bob

	move.l	#$1ff00,d1			; Bit zur Auswahl durch UND
	move.l	#$13000,d2			; Warte auf Zeile = $130 (304)
WarteY1:
	move.l	4(a5),d0			; VPOSR und VHPOSR - $dff004/$dff006
	and.l   d1,d0				; Whlen Sie nur die Bits der vertikalen Pos. 
	cmp.l   d2,d0				; Warte auf Zeile = $130 (304)
	bne.s	WarteY1

	bsr.w	RestoreBackground	; stellt den Hintergrund wieder her

	btst	#6,$bfe001			; linke Maustaste gedrckt?
	bne.s	Mouse				; Wenn nicht, gehe zurck zu Mouse:

	rts


;****************************************************************************
; Diese Routine stellt sicher, dass die Koordinaten des Bobs immer 
; innerhalb des Bildschirms erhalten bleiben.
;****************************************************************************

ControlCoordinate:
	tst.w	ObjX				; X berprfen
	bpl.s	NoMinX				; den linken Rand berprfen
	clr.w	ObjX				; Wenn X negativ ist, setze X = 0
	bra.s	ControlY			; Geh und berprfe das Y

NoMinX:
	cmp.w	#319-32,ObjX		; die rechte Kante berprfen in ObjX
								; Die Kantenkoordinate wird links vom Bob
								; gespeichert. Wenn es 319-32 erreicht hat,
								; dann ist die rechte Kante erreicht
								; d.h. die Koordinate X=319.
	bls.s	ControlY			; Wenn alles in Ordnung ist, berprfe das Y
	move.w	#319-32,ObjX		; Andernfalls wird die Koordinate an der Kante fixiert.

ControlY:
	tst.w	ObjY				; berprfe die obere Kante
	bpl.s	NoMinY				; Wenn es positiv ist, berprfe unten
	clr.w	ObjY				; andernfalls setze Y = 0
	bra.s	EndControl			; und geh raus

NoMinY:
	cmp.w	#255-11,ObjY		; die untere Kante berprfen in ObjY
								; Die Kantenkoordinate wird oben vom Bob
								; gespeichert. Wenn es Y = 255-11 erreicht hat,
								; dann ist die untere Kante erreicht
								; die Koordinate Y = 255 
	bls.s	EndControl			; Wenn alles in Ordnung ist, berprfe das Y
	move.w	#255-11,ObjY		; Andernfalls wird die Koordinate an der Kante fixiert.
EndControl:
	rts

;***************************************************************************
; Diese Routine zeichnet den BOB an die in den Variablen ObjX und ObjY 
; angegebenen Koordinaten. Der BOB und der Bildschirm sind im normalen Format  
; und daher werden die zu diesem Format gehrenden Formeln bei der Berechnung 
; der Werte, die in die Blitter-Register geschrieben werden benutzt. Auch die
; Technik, das letzte Wort des BOBs zu maskieren, ist in der Lektion zu sehen.
;****************************************************************************

;	     _, ,. ,_
;	     ////;\\\
;	    /'__  __`\
;	  _/  ______  \_
;	 (_   `'`'   _)
;	  /  _ (__) _  \ xCz
;	 / _ l______| _ \
;	/  (  `----'  )  \
;	\_____      _____/
;	    `--------'

DesignObject:
	lea	Bitplane,a0				; Ziel in a0
	move.w	ObjY(pc),d0			; Koordinate Y
	mulu.w	#40,d0				; Adresse berechnen: Jede Zeile besteht aus 40 Bytes
	add.w	d0,a0				; zur Anfangsadresse hinzufgen

	move.w	ObjX(pc),d0			; Koordinate X
	move.w	d0,d1				; Kopie
	and.w	#$000f,d0			; wir whlen die ersten 4 Bits aus, weil sie
								; in den Shifter von Kanal A eingefgt werden
	lsl.w	#8,d0				; die 4 Bits werden zum High-Nibble bewegt
	lsl.w	#4,d0				; des Wortes...
	or.w	#$09f0,d0			; ... rechts in das BLTCON0-Register einzugeben
	lsr.w	#3,d1				; (entspricht einer Division durch 8)
								; Runden auf ein Vielfaches von 8 fr den Zeiger
								; auf den Bildschirm, also auch auf ungerade Adressen
								; (also zu Bytes)
								; zB: eine 16 als Koordinate wird zu Byte 2
	and.w	#$fffe,d1			; Ich schliee Bit 0 aus
	add.w	d1,a0				; addieren zur Adresse der Bitebene, 
								; um die richtige Zieladresse zu finden

	lea	Figur,a1				; Quellzeiger
	moveq	#3-1,d7				; wiederhole es fr jede Ebene
PlaneLoop:
	btst	#6,2(a5)
WaitBlit2:
	btst	#6,2(a5)			; warte auf das Ende des Blitters
	bne.s	WaitBlit2

	move.l	#$ffff0000,$44(a5)	; BLTAFWM = $ffff es passiert alles
								; BLTALWM = $0000 setzt das letzte Wort zurck


	move.w	d0,$40(a5)			; BLTCON0 (A+D)
	move.w	#$0000,$42(a5)		; BLTCON1 (keine Spezialmodi)
	move.l	#$fffe0022,$64(a5)	; BLTAMOD=$fffe=-2 komm zurck
								; an den Anfang der Zeile.
								; BLTDMOD = 40-6 = 34 = $22 wie immer
	move.l	a1,$50(a5)			; BLTAPT  (an der Quellfigur fixiert)
	move.l	a0,$54(a5)			; BLTDPT  (Bildschirm)
	move.w	#(64*11)+3,$58(a5)	; BLTSIZE (Start Blitter !)

	lea	4*11(a1),a1				; zeigt auf die nchste Quellenebene
								; jede Bitplane ist 2 Wrter breit und 
								; 11 Zeilen hoch

	lea	40*256(a0),a0			; zeigt auf die nchste Zielebene
	dbra	d7,PlaneLoop

	rts

;****************************************************************************
; Diese Routine kopiert das Hintergrundrechteck, das von dem 
; BOB berschrieben wird in einem Puffer
;****************************************************************************

SaveBackground:
	lea	Bitplane,a0				; Ziel in a0
	move.w	ObjY(pc),d0			; Koordinate Y
	mulu.w	#40,d0				; Adresse berechnen: Jede Zeile besteht aus
								; 40 Bytes
	add.w	d0,a0				; zur Anfangsadresse hinzufgen

	move.w	ObjX(pc),d1			; Koordinate X
	lsr.w	#3,d1				; (entspricht einer Division durch 8)
								; Runden auf ein Vielfaches von 8 fr den Zeiger
								; auf den Bildschirm, also auch auf ungerade Adressen
								; (also zu Bytes)
								; zB: eine 16 als Koordinate wird zu Byte 2
	and.w	#$fffe,d1			; Ich schliee Bit 0 aus
	add.w	d1,a0				; addieren zur Adresse der Bitebene, 
								; um die richtige Zieladresse zu finden

	lea	Buffer,a1				; Zieladresse
	moveq	#3-1,d7				; wiederhole es fr jede Ebene
PlaneLoop2:
	btst	#6,2(a5)			; DMACONR
WaitBlit3:
	btst	#6,2(a5)			; DMACONR - warte auf das Ende des Blitters
	bne.s	WaitBlit3

	move.l	#$ffffffff,$44(a5)	; BLTAFWM = $ffff lass alles passieren
								; BLTALWM = $ffff lass alles passieren
								
	move.l	#$09f00000,$40(a5)	; BLTCON0 und BLTCON1 Kopie von A nach D
	move.l	#$00220000,$64(a5)	; BLTAMOD=40-4=36=$24
								; BLTDMOD=0 im Puffer
	move.l	a0,$50(a5)			; BLTAPT - Adresse Quelle
	move.l	a1,$54(a5)			; BLTDPT - Puffer
	move.w	#(64*11)+3,$58(a5)	; BLTSIZE (starte Blitter !)

	lea	40*256(a0),a0			; zeigt auf die nchste Quellebene
	lea	6*11(a1),a1				; zeigt auf die nchste Zielebene
								; Jeder Blitt ist 3 Wrter breit und 
								; 11 Zeilen hoch
	dbra	d7,PlaneLoop2

	rts

;****************************************************************************
; Diese Routine kopiert den Inhalt des Puffers in das Bildschirmrechteck
; welches es vor dem Zeichnen des BOB enthielt. Auf diese Weise kommt auch
; das gelschte BOB von der alten Position.
;****************************************************************************

RestoreBackground:
	lea	Bitplane,a0				; Ziel in a0
	move.w	ObjY(pc),d0			; Koordinate Y
	mulu.w	#40,d0				; Adresse berechnen: Jede Zeile besteht aus 40 Bytes
	add.w	d0,a0				; zur Anfangsadresse hinzufgen

	move.w	ObjX(pc),d1			; Koordinate X
	lsr.w	#3,d1				; (entspricht einer Division durch 8)
								; Runden auf ein Vielfaches von 8 fr den Zeiger
								; auf den Bildschirm, also auch auf ungerade Adressen
								; (also zu Bytes)
								; zB: eine 16 als Koordinate wird zu Byte 2
	and.w	#$fffe,d1			; Ich schliee Bit 0 aus
	add.w	d1,a0				; addieren zur Adresse der Bitebene, 
								; um die richtige Zieladresse zu finden

	lea	Buffer,a1				; Zieladresse
	moveq	#3-1,d7				; wiederhole es fr jede Ebene
PlaneLoop3:
	btst	#6,2(a5)			; DMACONR
WBlit4:
	btst	#6,2(a5)			; warte auf das Ende des Blitters
	bne.s	wblit4

	move.l	#$ffffffff,$44(a5)	; BLTAFWM = $ffff lass alles passieren
								; BLTALWM = $ffff lass alles passieren
								
	move.l	#$09f00000,$40(a5)	; BLTCON0 und BLTCON1 Kopie von A nach D
	move.l	#$00000022,$64(a5)	; BLTAMOD=0 (buffer)
								; BLTDMOD=40-6=34=$22
	move.l	a1,$50(a5)			; BLTAPT (buffer)
	move.l	a0,$54(a5)			; BLTDPT (Bildschirm)
	move.w	#(64*11)+3,$58(a5)	; BLTSIZE (starte Blitter !)

	lea	40*256(a0),a0			; zeigt auf die nchste Zielebene
	lea	6*11(a1),a1				; zeigt auf die nchste Quellebene
								; Jeder Blitt ist 3 Wrter breit und 
								; 11 Zeilen hoch
	dbra	d7,PlaneLoop3
	rts

;****************************************************************************
; Diese Routine liest die Maus und aktualisiert die Werte in den
; Variablen ObjX und ObjY 
;****************************************************************************

ReadMouse:
	move.b	$dff00a,d1			; JOY0DAT - vertikale Mausposition
	move.b	d1,d0				; Kopie in d0
	sub.b	MouseY(pc),d0		; subtrahieren der alten Mausposition
	beq.s	NoVert				; Wenn die Differenz = 0 ist, steht die Maus still
	ext.w	d0					; wandelt das Byte in ein Wort um
	add.w	d0,ObjY				; Objektposition ndern

NoVert:
  	move.b	d1,MouseY			; speichern der Mausposition fr das nchste Mal

	move.b	$dff00b,d1			; JOY0DAT - horizontale Mausposition
	move.b	d1,d0				; Kopie in d0
	sub.b	MouseX(pc),d0		; subtrahieren der alten Mausposition
	beq.s	NoHoriz				; Wenn die Differenz = 0 ist, steht die Maus still
	ext.w	d0					; wandelt das Byte in ein Wort um
	add.w	d0,ObjX				; Objektposition ndern
NoHoriz
  	move.b	d1,MouseX			; speichern der Mausposition fr das nchste Mal
	rts

ObjY:		dc.w	0			; hier wird das Y des Objektes gespeichert
ObjX:		dc.w	0			; hier wird das X des Objektes gespeichert
MouseY:		dc.b	0			; hier wird das Y der Maus gespeichert
MouseX:		dc.b	0			; hier wird das X der Maus gespeichert

;****************************************************************************

	SECTION	GRAPHIC,DATA_C

Copperlist:
	dc.w	$8e,$2c81			; DIWSTRT
	dc.w	$90,$2cc1			; DIWSTOP
	dc.w	$92,$38				; DDFSTRT
	dc.w	$94,$d0				; DDFSTOP
	dc.w	$102,0				; BPLCON1
	dc.w	$104,0				; BPLCON2
	dc.w	$108,0				; WERT Modulo = 0
	dc.w	$10a,0				; BEIDE Modulo MIT ZUM GLEICHEN WERT.

	dc.w	$100,$3200			; BPLCON0 - 3 Bitplanes lowres

Bplpointers:
	dc.w	$e0,$0000,$e2,$0000	; erste Bitplane
	dc.w	$e4,$0000,$e6,$0000
	dc.w	$e8,$0000,$ea,$0000

	dc.w	$0180,$000			; COLOR00
	dc.w	$0182,$475			; COLOR01
	dc.w	$0184,$fff			; COLOR02
	dc.w	$0186,$ccc			; COLOR03
	dc.w	$0188,$999			; COLOR04
	dc.w	$018a,$232			; COLOR05
	dc.w	$018c,$777			; COLOR06
	dc.w	$018e,$444			; COLOR07

	dc.w	$ffff,$fffe			; Ende Copperlist

;****************************************************************************

; Dies sind die Daten, aus denen sich die Bob-Figur zusammensetzt.
; Der Bob ist im normalen Format, 32 Pixel breit (2 Wrter)
; 11 Zeilen hoch und wird von 3 Bitplanes gebildet

Figur:
	dc.l	$007fc000			; plane 1
	dc.l	$03fff800
	dc.l	$07fffc00
	dc.l	$0ffffe00
	dc.l	$1fe07f00
	dc.l	$1fe07f00
	dc.l	$1fe07f00
	dc.l	$0ffffe00
	dc.l	$07fffc00
	dc.l	$03fff800
	dc.l	$007fc000

	dc.l	$00000000			; plane 2
	dc.l	$007fc000
	dc.l	$03fff800
	dc.l	$07fffc00
	dc.l	$0fe07e00
	dc.l	$0fe07e00
	dc.l	$0fe07e00
	dc.l	$07fffc00
	dc.l	$03fff800
	dc.l	$007fc000
	dc.l	$00000000

	dc.l	$007fc000			; plane 3
	dc.l	$03803800
	dc.l	$04000400
	dc.l	$081f8200
	dc.l	$10204100
	dc.l	$10204100
	dc.l	$10204100
	dc.l	$081f8200
	dc.l	$04000400
	dc.l	$03803800
	dc.l	$007fc000

;****************************************************************************

Bitplane:
	incbin	"/Sources/amiga.raw"		
					; hier laden wir die figur
					; konvertiert mit KEFCON.

;****************************************************************************

	SECTION	BUFFER,BSS_C

; Dies ist der Puffer, in dem wir von Zeit zu Zeit den Hintergrund speichern.
; Er hat die gleichen Abmessungen wie ein Blitt: Hhe 11 Zeilen, Breite 3 Worte
; 3 Bitplanes

Buffer:
	ds.w	11*3*3

	end

;****************************************************************************

In diesem Beispiel gehen wir das Hintergrundproblem von BOBs an.
Wir werden nicht die endgltige Lsung anbieten, die Verstndnis der Blitter-
eigenschaften erfordert, die im Kurs noch nicht erklrt wurden. Aber wir werden 
einen erster Schritt machen. Die Idee ist die folgende: Bevor Sie das BOB auf
dem Bildschirm zeichnen, kopieren wir den Teil des Hintergrunds, der vom BOB
berschrieben wird in einen Puffer. Dann zeichnen wir ganz normal das BOB. Nach
dem vertikal blank mssen wir das BOB lschen, (wodurch der Bildschirm leer
bliebe). Aus diesem Grund kopieren wir den Hintergrund der zuvor an dieser
Stelle war hierhin zurck. Auf diese Weise lschen wir die alte Kopie des BOBs
und wir setzen den Hintergrund zurck, der dort vor seinem Durchgang war. Das
Problem bei dieser Technik ist, wie Sie sehen, dass Sie den Hintergrund in den
Bereichen im Rechteck, die das BOB einschlieen nicht sehen. Das liegt an der
Tatsache, dass die mit der COLOR00 gefrbten Teile des BOBs nicht transparent
sind, wie das bei Sprites der Fall ist, sondern sie reprsentieren die 
Hintergrundfarbe. Wir werden spter die Lsung fr dieses Problem sehen.
                                                                                 