
; Listing10d1.s		BOB mit Hintergrundsanierung.
; linke Taste zum Beenden.

	SECTION	BLIT,CODE

;	include	"DaWorkBench.s"	; entferne das ; vor dem Speichern mit "wo"

*****************************************************************************
	include	"/Sources/startup1.s"	; speichern Copperlist etc.
*****************************************************************************

			;5432109876543210
DMASET	equ	%1000001111000000	; Bitplane, Copper, Blitter DMA


Start:
	move.l	#Bitplane,d0		; Zeiger auf das Bild
	lea	Bplpointers,a1			; Bitplanepointer
	moveq	#3-1,d1				; Anzahl der Bitebenen (hier sind 3)
PointBp:
	move.w	d0,6(a1)
	swap	d0
	move.w	d0,2(a1)
	swap	d0
	add.l	#40*256,d0			; + Lnge einer Bitplane !!!!!
	addq.w	#8,a1
	dbra	d1,PointBp

	lea	$dff000,a5				; Custom Register Base in a5
	move.w	#DMASET,$96(a5)		; DMACON - einschalten Bitplane, Copper, Blitter
	move.l	#Copperlist,$80(a5)	; Zeiger Copperlist
	move.w	d0,$88(a5)			; Start Copperlist
	move.w	#0,$1fc(a5)			; AGA "deaktivieren"
	move.w	#$c00,$106(a5)		; AGA "deaktivieren"
	move.w	#$11,$10c(a5)		; AGA "deaktivieren"

Mouse:

	bsr.w	ReadMouse			; lies Koordinaten
	bsr.s	ControlCoordinate	; verhindert, dass der Bob den Bildschirm verlsst
	bsr.w	SaveBackground		; speichere den Hintergrund
	bsr.s	DesignObject		; zeichne den Bob

	move.l	#$1ff00,d1			; Bit zur Auswahl durch UND
	move.l	#$13000,d2			; Warte auf Zeile $130 (304)
WarteY1:
	move.l	4(a5),d0			; VPOSR und VHPOSR - $dff004/$dff006
	and.l   d1,d0				; Whlen Sie nur die Bits der vertikalen Pos.
	cmp.l   d2,d0				; Warte auf Zeile $130 (304)
	bne.s	WarteY1

	bsr.w	RestoreBackground	; stelle den Hintergrund wieder her


	btst	#6,$bfe001			; linke Maustaste gedrckt?
	bne.s	Mouse				; wenn nicht, gehe zurck zu Mouse:

	rts


;****************************************************************************
; Diese Routine stellt sicher, dass die Koordinaten des Bobs immer 
; innerhalb des Bildschirms erhalten bleiben.
;****************************************************************************

ControlCoordinate:
	tst.w	ObjX				; X berprfen
	bpl.s	NoMinX				; den linken Rand berprfen
	clr.w	ObjX				; Wenn X negativ ist, setze X = 0
	bra.s	ControlY			; Geh und berprfe das Y

NoMinX:
	cmp.w	#319-32,ObjX		; berprfe die rechte Kante in ObjX
								; die Kantenkoordinate wird links vom Bob
								; gespeichert. Wenn es 319-32 erreicht hat,
								; dann ist die rechte Kante erreicht
								; d.h. die Koordinate X=319.
	bls.s	ControlY			; Wenn alles in Ordnung ist, berprfe das Y
	move.w	#319-32,ObjX		; Andernfalls wird die Koordinate an der Kante fixiert.

ControlY:
	tst.w	ObjY				; berprfe die obere Kante
	bpl.s	NoMinY				; Wenn es positiv ist, berprfe unten
	clr.w	ObjY				; Andernfalls setze Y = 0
	bra.s	EndControl			; und geh raus

NoMinY:
	cmp.w	#255-11,ObjY		; berprfe die untere Kante in ObjY
								; die Kantenkoordinate wird oben vom Bob 
								; gespeichert. Wenn es Y = 255-11 erreicht hat,
								; dann ist die untere Kante erreicht
								; d.h. die Koordinate Y = 255
	bls.s	EndControl			; Wenn alles in Ordnung ist, berprfe das Y
	move.w	#255-11,ObjY		; Andernfalls wird die Koordinate an der Kante fixiert.
EndControl:
	rts

;***************************************************************************
; Diese Routine zeichnet den BOB an die in den Variablen ObjX und ObjY 
; angegebenen Koordinaten. Der BOB und der Bildschirm sind im normalen Format 
; und daher werden die zu diesem Format gehrenden Formeln bei der Berechnung 
; der Werte, die in die Blitter-Register geschrieben werden benutzt. Auch die
; Technik, das letzte Wort des BOBs zu maskieren, ist in der Lektion zu sehen.
;****************************************************************************

;	.         .     ___
;	 .    /\_/\_\\|/))
;	 _______/. @  \/ /
;	(|O|___ /      \/
;	 |_| /  \_______/~
;	 :  /     `:  \
;	 . _\   ___. _  \
;	  * \ /  /.    /
;	 /aL \\_/______/
;	          `----'

DesignObject:
	lea	Bitplane,a0				; Ziel in a0
	move.w	ObjY(pc),d0			; Koordinate Y
	mulu.w	#40,d0				; Adresse berechnen: Jede Zeile besteht aus
								; 40 Bytes
	add.w	d0,a0				; zur Anfangsadresse hinzufgen

	move.w	ObjX(pc),d0			; Koordinate X
	move.w	d0,d1				; Kopie
	and.w	#$000f,d0			; wir whlen die ersten 4 Bits, weil sie 
								; in den Shifter von Kanal A eingefgt werden
	lsl.w	#8,d0				; die 4 Bits werden zum High-Nibble bewegt
	lsl.w	#4,d0				; des Wortes...
	move.w	d0,d2

	or.w	#$0fca,d0			; ... rechts in das BLTCON0-Register einzugeben
	lsr.w	#3,d1				; (entspricht einer Division durch 8)
								; Runden auf ein Vielfaches von 8 fr den Zeiger
								; auf den Bildschirm, also auch auf ungerade Adressen
								; (also zu Bytes)
								; zB: eine 16 als Koordinate wird zu Byte 2
	and.w	#$fffe,d1			; Ich schliee Bit 0 aus
	add.w	d1,a0				; addieren zur Adresse der Bitebene, 
								; um die richtige Zieladresse zu finden

	lea	Figur,a1				; Zeiger Quelle
	moveq	#3-1,d7				; wiederhole es fr jede Ebene
PlaneLoop:
	btst	#6,2(a5)
WaitBlit2:
	btst	#6,2(a5)			; warte auf das Ende des Blitters
	bne.s	WaitBlit2

	move.l	#$ffff0000,$44(a5)	; BLTAFWM = $ffff es passiert alles
								; BLTALWM = $0000 setzt das letzte Wort zurck
								
	move.w	d0,$40(a5)			; BLTCON0 (A+D)
	move.w	d2,$42(a5)			; BLTCON1 (keine Spezialmodi)
	move.l	#$0022fffe,$60(a5)	; BLTCMOD und BLTBMOD
	move.l	#$fffe0022,$64(a5)	; BLTAMOD=$fffe=-2 komm 
								; zum Anfang der Zeile zurck.
								; BLTDMOD=40-6=34=$22 wie blich
	move.l	#Maske,$50(a5)		; BLTAPT (an der Maske fixiert)
	move.l	a1,$4c(a5)			; BLTBPT (Figur Bob)
	move.l	a0,$48(a5)			; BLTCPT (Bildschirm)
	move.l	a0,$54(a5)			; BLTDPT (Bildschirm)	
	move.w	#(64*11)+3,$58(a5)	; BLTSIZE (Blitter starten!)

	lea	4*11(a1),a1				; zeigt auf die nchste Quellebene
								; jede Bitplane ist 2 Wrter breit und 
								; 11 Zeilen hoch

	lea	40*256(a0),a0			; zeigt auf die nchste Zielebene
	dbra	d7,PlaneLoop

	rts

;****************************************************************************
; Diese Routine kopiert das Hintergrundrechteck, das mit dem BOB 
; berschrieben wird in einen Puffer
;****************************************************************************

SaveBackground:
	lea	Bitplane,a0				; Ziel in a0
	move.w	ObjY(pc),d0			; Koordinate Y
	mulu.w	#40,d0				; Adresse berechnen: Jede Zeile besteht aus
								; 40 Bytes
	add.w	d0,a0				; zur Anfangsadresse hinzufgen

	move.w	ObjX(pc),d1			; Koordinate X
	lsr.w	#3,d1				; (entspricht einer Division durch 8)
								; Runden auf ein Vielfaches von 8 fr den Zeiger
								; auf den Bildschirm, also auch auf ungerade Adressen
								; (also zu Bytes)
								; zB: eine 16 als Koordinate wird zu Byte 2
	and.w	#$fffe,d1			; Ich schliee Bit 0 aus
	add.w	d1,a0				; addieren zur Adresse der Bitebene, 
								; um die richtige Zieladresse zu finden

	lea	Buffer,a1				; Adresse Ziel
	moveq	#3-1,d7				; wiederhole es fr jede Ebene
PlaneLoop2:
	btst	#6,2(a5)			; DMACONR
WaitBlit3:
	btst	#6,2(a5)			; DMACONR - warte auf das Ende des Blitters
	bne.s	WaitBlit3

	move.l	#$ffffffff,$44(a5)	; BLTAFWM = $ffff es passiert alles
								; BLTALWM = $ffff es passiert alles

	move.l	#$09f00000,$40(a5)	; BLTCON0 und BLTCON1 Kopie von A nach D
	move.l	#$00220000,$64(a5)	; BLTAMOD=40-6=34=$22
								; BLTDMOD=0 im Puffer
	move.l	a0,$50(a5)			; BLTAPT - Adresse Quelle
	move.l	a1,$54(a5)			; BLTDPT - Puffer
	move.w	#(64*11)+3,$58(a5)	; BLTSIZE (Blitter starten !)

	lea	40*256(a0),a0			; zeigt auf die nchste Quellebene
	lea	6*11(a1),a1				; zeigt auf die nchste Zielebene
								; Jeder Blitt ist 3 Wrter breit und 
								; 11 Zeilen hoch
	dbra	d7,PlaneLoop2

	rts

;****************************************************************************
; Diese Routine kopiert den Inhalt des Puffers in das Bildschirmrechteck
; was es vor der BOB-Zeichnung enthielt. Auf diese Weise kommt es auch, das
; das BOB vom alten Standort gelscht wird.
;****************************************************************************

RestoreBackground:
	lea	Bitplane,a0				; Ziel in a0
	move.w	ObjY(pc),d0			; Koordinate Y
	mulu.w	#40,d0				; Adresse berechnen: Jede Zeile besteht aus
								; 40 Bytes
	add.w	d0,a0				; zur Anfangsadresse hinzufgen

	move.w	ObjX(pc),d1			; Koordinate  X
	lsr.w	#3,d1				; (entspricht einer Division durch 8)
								; Runden auf ein Vielfaches von 8 fr den Zeiger
								; auf den Bildschirm, also auch auf ungerade Adressen
								; (also zu Bytes)
								; zB: eine 16 als Koordinate wird zu Byte 2
	and.w	#$fffe,d1			; Ich schliee Bit 0 aus
	add.w	d1,a0				; addieren zur Adresse der Bitebene, 
								; um die richtige Zieladresse zu finden

	lea	Buffer,a1				; Adresse Quelle
	moveq	#3-1,d7				; wiederhole es fr jede Ebene
PlaneLoop3:
	btst	#6,2(a5)			; DMACONR
WaitBlit4:
	btst	#6,2(a5)			; warte auf das Ende des Blitters
	bne.s	WaitBlit4

	move.l	#$ffffffff,$44(a5)	; BLTAFWM = $ffff es passiert alles
								; BLTALWM = $ffff es passiert alles

	move.l	#$09f00000,$40(a5)	; BLTCON0 und BLTCON1 Kopie von A nach D
	move.l	#$00000022,$64(a5)	; BLTAMOD=0 (Puffer)
								; BLTDMOD=40-6=34=$22
	move.l	a1,$50(a5)			; BLTAPT (Puffer)
	move.l	a0,$54(a5)			; BLTDPT (Bildschirm)
	move.w	#(64*11)+3,$58(a5)	; BLTSIZE (Blitter starten !)

	lea	40*256(a0),a0			; zeigt auf die nchste Zielebene
	lea	6*11(a1),a1				; zeigt auf die nchste Quellebene
								; Jeder Blitt ist 3 Wrter breit und 
								; 11 Zeilen hoch
	dbra	d7,PlaneLoop3
	rts

;****************************************************************************
; Diese Routine liest die Maus und aktualisiert die Werte in den
; Variablen ObjX und ObjY 
;****************************************************************************

ReadMouse:
	move.b	$dff00a,d1			; JOY0DAT - vertikale Mausposition
	move.b	d1,d0				; Kopie in d0
	sub.b	MouseY(pc),d0		; subtrahieren der alten Mausposition
	beq.s	NoVert				; Wenn die Differenz = 0 ist, steht die Maus still
	ext.w	d0					; wandelt das Byte in ein Wort um
	add.w	d0,ObjY				; Objektposition ndern

NoVert:
  	move.b	d1,MouseY			; speichern der Mausposition fr das nchste Mal

	move.b	$dff00b,d1			; JOY0DAT - horizontale Mausposition
	move.b	d1,d0				; Kopie in d0
	sub.b	MouseX(pc),d0		; subtrahieren der alten Mausposition
	beq.s	NoHoriz				; Wenn die Differenz = 0 ist, steht die Maus still
	ext.w	d0					; wandelt das Byte in ein Wort um
	add.w	d0,ObjX				; Objektposition ndern
NoHoriz:
  	move.b	d1,MouseX			; speichern der Mausposition fr das nchste Mal
	rts

ObjY:		dc.w	0			; hier wird das Y des Objektes gespeichert
ObjX:		dc.w	0			; hier wird das X des Objektes gespeichert
MouseY:		dc.b	0			; hier wird das Y der Maus gespeichert
MouseX:		dc.b	0			; hier wird das X der Maus gespeichert

;****************************************************************************

	SECTION	GRAPHIC,DATA_C

Copperlist:
	dc.w	$8e,$2c81			; DIWSTRT
	dc.w	$90,$2cc1			; DIWSTOP
	dc.w	$92,$38				; DDFSTRT
	dc.w	$94,$d0				; DDFSTOP
	dc.w	$102,0				; BPLCON1
	dc.w	$104,0				; BPLCON2
	dc.w	$108,0				; Wert MODULO = 0
	dc.w	$10a,0				; BEIDE MODULO MIT GLEICHEN WERT.

	dc.w	$100,$3200			; BPLCON0 - 3 Bitplanes lowres

Bplpointers:
	dc.w	$e0,$0000,$e2,$0000	; erste Bitplane
	dc.w	$e4,$0000,$e6,$0000
	dc.w	$e8,$0000,$ea,$0000

	dc.w	$0180,$000			; COLOR00
	dc.w	$0182,$475			; COLOR01
	dc.w	$0184,$fff			; COLOR02
	dc.w	$0186,$ccc			; COLOR03
	dc.w	$0188,$999			; COLOR04
	dc.w	$018a,$232			; COLOR05
	dc.w	$018c,$777			; COLOR06
	dc.w	$018e,$444			; COLOR07

	dc.w	$ffff,$fffe			; Ende Copperlist

;****************************************************************************

; Dies sind die Daten, aus denen sich die Bob-Grafik zusammensetzt.
; Der Bob ist im normalen Format, 32 Pixel breit (2 Wrter)
; 11 Zeilen hoch und wird von 3 Bitebenen gebildet

Figur:	
	dc.l	$007fc000			; plane 1
	dc.l	$03fff800
	dc.l	$07fffc00
	dc.l	$0ffffe00
	dc.l	$1fe07f00
	dc.l	$1fe07f00
	dc.l	$1fe07f00
	dc.l	$0ffffe00
	dc.l	$07fffc00
	dc.l	$03fff800
	dc.l	$007fc000

	dc.l	$00000000			; plane 2
	dc.l	$007fc000
	dc.l	$03fff800
	dc.l	$07fffc00
	dc.l	$0fe07e00
	dc.l	$0fe07e00
	dc.l	$0fe07e00
	dc.l	$07fffc00
	dc.l	$03fff800
	dc.l	$007fc000
	dc.l	$00000000

	dc.l	$007fc000			; plane 3
	dc.l	$03803800
	dc.l	$04000400
	dc.l	$081f8200
	dc.l	$10204100
	dc.l	$10204100
	dc.l	$10204100
	dc.l	$081f8200
	dc.l	$04000400
	dc.l	$03803800
	dc.l	$007fc000

Maske:
	dc.l	$007fc000
	dc.l	$03fff800
	dc.l	$07fffc00
	dc.l	$0ffffe00
	dc.l	$1fe07f00
	dc.l	$1fe07f00
	dc.l	$1fe07f00
	dc.l	$0ffffe00
	dc.l	$07fffc00
	dc.l	$03fff800
	dc.l	$007fc000



;****************************************************************************

Bitplane:
	incbin	"/Sources/amiga.raw"			; Hier laden wir die Figur

;****************************************************************************

	SECTION	BUFFER,BSS_C

; Dies ist der Puffer, in dem wir den Hintergrund von Zeit zu Zeit speichern.
; Er hat die gleichen Abmessungen wie ein Blitt: Hhe 11 Zeilen, 
; Breite 3 Wrter, 3 Bitebenen

Buffer:
	ds.w	11*3*3

	end

;****************************************************************************

In diesem Beispiel lsen wir das Hintergrundproblem der BOBs. Die Struktur des 
Programms ist dasselbe wie im Listing9i3.s. Die Unterschiede sind alle in der 
Routine "DesignObject". Die bernimmt die Zeichnungsprozedur wie in der 
Lektion erklrt. Wie Sie fr die Blitts sehen knnen setzen wir LF = $ca
cookie-cut) und wir benutzen alle Kanle des Blitters (A fr die Maske, 
B fr den BOB und C fr den Hintergrund).                     